=== modified file 'diff.py'
--- diff.py	2008-05-10 03:23:00 +0000
+++ diff.py	2008-05-12 20:21:45 +0000
@@ -479,6 +479,8 @@
                        _('Please resolve the conflicts manually'
                          ' before committing.'))
 
+    def _handle_error(self, e):
+        error_dialog('Error', str(e))
 
     def _get_save_path(self, basename):
         d = gtk.FileChooserDialog('Save As', self,
@@ -550,7 +552,7 @@
 
 class MergeDirectiveController(DiffController):
 
-    def __init__(self, path, directive, window):
+    def __init__(self, path, directive, window=None):
         DiffController.__init__(self, path, directive.patch.splitlines(True),
                                 window)
         self.directive = directive
@@ -582,7 +584,7 @@
                     # There are conflicts to be resolved.
                 self.window.destroy()
             except Exception, e:
-                error_dialog('Error', str(e))
+                self.window._handle_error(e)
         finally:
             tree.unlock()
 

=== modified file 'tests/test_diff.py'
--- tests/test_diff.py	2008-05-10 03:23:00 +0000
+++ tests/test_diff.py	2008-05-12 20:21:45 +0000
@@ -18,7 +18,7 @@
 from cStringIO import StringIO
 import os
 
-from bzrlib import tests
+from bzrlib import errors, tests
 from bzrlib.merge_directive import MergeDirective
 
 from bzrlib.plugins.gtk.diff import (
@@ -121,6 +121,9 @@
     def _conflicts(self):
         self.conflicts = True
 
+    def _handle_error(self, e):
+        self.handled_error = e
+
 
 class TestDiffController(tests.TestCaseWithTransport):
 
@@ -197,6 +200,13 @@
         self.assertEqual(other.last_revision(), this.get_parent_ids()[1])
         self.assertFileEqual('bar', 'this/foo')
 
+    def test_perform_merge_uncommitted_changes(self):
+        this, other, directive = self.make_this_other_directive()
+        self.build_tree_contents([('this/foo', 'bar')])
+        this.add('foo')
+        window = self.make_merged_window(directive)
+        self.assertIsInstance(window.handled_error, errors.UncommittedChanges)
+
 
 class Test_IterChangesToStatus(tests.TestCaseWithTransport):
 

